(*
 Oukseh Lee, The LET Project, KAIST

 Copyright(c) 2000-2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

structure Init = struct
  val dirs = ref ([]: string list)

  fun read_dirs dir = ((
    let val d = Unix.opendir dir
        fun f() = let val a = Unix.readdir d in a::f() end
                    handle End_of_file => []
        val l = f()
    in  Unix.closedir d; 
        List.filter (fn s => Filename.check_suffix s Dump.dumpext) l 
    end) handle _ => [])

  fun init ds = 
    let val dirs = Config.standard_library :: ds
(*
        val files = let val nfiles = open_in ".nlibs"
                        val flist = ref []
                    in  (while true do
                          let val fname = input_line nfiles
                          in  if Filename.check_suffix fname ".n" then
                                flist := ((Filename.chop_suffix fname ".n")^".nty") :: (!flist)
                          end
                        end handle End_of_file => ());
                        close_in nfiles;
                        !flist
                    end handle Sys_error _ => []
*)
        val files = List.flatten 
                      (List.map (fn dir => List.map (Filename.concat dir) (read_dirs dir)) 
                                dirs)
        val _ = NEnv.set_base (Predef.init)

        val bs = List.iter (fn f => ((let (* val _ = Format.printf "Load %s.@." f *)
                                          val (b,c) = Dump.load f
                                      in  NEnv.add_base b;
                                          Ty.CE.add_ce c
                                      end) handle Dump.Invalid_header => ()
                                              (* TyError.warning (f^" () ٸ  ϵǾ ֽϴ.") *)
                                                | Sys_error _ => ())) files
        val _ = NEnv.init_open "Pervasives"
    in  () end
        
end
